#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>
#include "pollute.h"

/* THis is written and tested on a Linux box, and to
 * ANSI C standards so it shoudl compile and run on any
 * platform including Visual C++ [sic] and windows
 */


/* Forward declarations */

void setsuffix(char *);
int getopts(int, char **);
void startloop(int, int); //done
void create_addr(char *);
FILE * getfiledes(char *, int); //done
void gencgi_header(FILE *);
void readconfig(void);
char *crypt_filename(const char *, int); // done
char *name(long, const char *, int);
void get_string(char *);
void usage(char *);

/* Set Global Defaults... */

long key;
int mode=FALSE;
int msgsperpage=1000;
int numpages=5;
int domlength=8;
int emaillen=8;
int randaddlen=FALSE;
int randsuffix=FALSE;
int randhost=FALSE;
int garbage=FALSE;
char filename[64]="pollute.htm";

char chars[]="1234567890abcdefghijklmnopqrstuvwxyz";

char *allsuffixes[] = { "com", "net", "org", "gov",
												"co.uk", "biz", "info", "name",
												"com.au", "net.au", "edu", "edu.au",
												"gov.au", "gov.uk", "ac.uk",
												"af", "al", "dz", "as", "ad",
												"ao", "ai", "aq", "ag", "ar",
												"am", "aw", "au", "at", "az",
												"bs", "bh", "bd", "bb", "by",
												"be", "bz", "bj", "bm", "bt",
												"bo", "ba", "bw", "bv", "br",
												"io", "bn", "bg", "bf", "bi",
												"kh", "cm", "ca", "cv", "ky",
												"cf", "td", "cl", "cn", "cx",
												"cc", "cc", "co", "km", "cg",
												"cd", "ck", "cr", "ci", "hr",
												"cu", "cy", "cz", "dk", "dj",
												"dm", "do", "tp", "ec", "eg",
												"sv", "gq", "er", "ee", "et",
												"fk", "fo", "fj", "fi", "fr",
												"gf", "pf", "tf", "ga", "gm",
												"ge", "de", "gh", "gi", "gr",
												"gl", "gd", "gp", "gu", "gt",
												"gn", "gw", "gy", "ht", "hm",
												"va", "hn", "hk", "hu", "is",
												"in", "id", "ir", "iq", "ie",
												"il", "it", "jm", "jp", "jo",
												"kz", "ke", "ki", "kp", "kr",
												"kw", "kg", "la", "lv", "lb",
												"ls", "lr", "ly", "li", "lt",
												"lu", "mo", "mk", "mg", "mw",
												"my", "mv", "ml", "mt", "mh",
												"mq", "mr", "mu", "yt", "mx",
												"fm", "md", "mc", "mn", "ms",
												"ma", "mz", "mm", "na", "nr",
												"np", "nl", "an", "nc", "nz",
												"ni", "ne", "ng", "nu", "nf",
												"mp", "no", "om", "pk", "pw",
												"ps", "pa", "pg", "py", "pe",
												"ph", "pn", "pl", "pt", "pr",
												"qa", "re", "ro", "ru", "rw",
												"sh", "kn", "lc", "pm", "vc",
												"ws", "sm", "st", "sa", "sn",
												"sn", "sc", "sl", "sg", "sk",
												"si", "sb", "so", "za", "gs",
												"es", "lk", "sd", "sr", "sj",
												"sz", "se", "ch", "sy", "tw",
												"tj", "tz", "th", "tg", "tk",
												"to", "tt", "tn", "tr", "tm",
												"tc", "tv", "ug", "ua", "ae",
												"gb", "us", "um", "uy", "uz",
												"vu", "ve", "vn", "vg", "vi",
												"wf", "eh", "ye", "yu", "zm",
												"zw", "info" };

/* define the number of elements in the suffixes array */
#define SUFFIXES 256

char *suffix;

/* main(): Start of main loop */


int main (int argc, char **argv) {

/* first check command line vars....
 * 2 modes:
 *
 * 1/ Command line to generate static pages.
 * 2/ dynamic mode - config file and no command line options
 *
 * Command line options:
 * -n <1000> number of generated addresses per page
 * -p <5> number of calls for other pages
 * -d <8> max. length of domain strings (3-64) not including suffix.
 * -e <8> max. length of e-mail address parts
 * -r [present] will force address length randomization
 *              (to lengths specified by options 'e' and 'd')
 * -s [present] will force address suffix to be randomized
 * -s [not present] will use .com .net and .org suffixes only
 * -g [present] do not add random text 'garbage' to pages
 *              (garbage is random groups of characters as text)
 * -h [present] use random hostnames in the current domain.
 * -f <pollute.htm> specify the starting filename
 *
 * Config File Options:
 *
 * <to be completed>
 *
 */
	
	int l;
	char *s;

	/* Initialise the key */
	
	srand(time(NULL));
	key=time(NULL)+rand();
	
	/* First we'll get the command line stuff
	 * Return false for command line mode, true for config file
	 */
	
	mode=getopts(argc, argv);
	
	if (mode) readconfig();
	// if (randhost) suffix=setsuffix();

	l=1;


	/* this should run 'numpages' times or once is in configfile mode */
	do {
		startloop(mode, l);	
		l++;
	} while (l<(numpages+1) && !mode);

}

void startloop(int mode, int iteration) {

	int l;
	char *filename;
	FILE *fp;
	char *addrp, *sp, *refp;
	char addr[256], str[10], ref[10];;

	addrp=&addr[0];
	sp=&str[0];
	refp=&ref[0];
	
	if (mode) {
		fp=stdout;
		gencgi_header(fp);
	} else {
		fp=(FILE *)getfiledes(filename, iteration);
	}
	
	fprintf(fp, "<HTML>\n<HEAD>\n</HEAD>\n<BODY>\n");
	
	for(l=0; l<numpages; l++)
	{
		get_string(refp);
		get_string(sp);
		fprintf(fp, "<A HREF=\"%s.html\">%s</A><BR>\n", refp, sp);
	}

	for(l=0; l<msgsperpage; l++) {

		create_addr(addrp);
		setsuffix(addrp);
		
		if (garbage) {
			get_string(refp);
			get_string(sp);
			fprintf(fp, "<A HREF=\"mailto: %s\">%s</A> %s<BR>\n", addr, refp, str);
		} else {
			fprintf(fp, "<A HREF=\"mailto: %s\">%s</A><BR>\n", addr, addr);
		}
		
	}
	
	fprintf(fp, "</BODY>\n</HTML>\n");

	if (!mode) fclose(fp);

}
	
FILE *getfiledes(char *filename, int seed) {

	FILE *file;
	char *fname;
	
	if (seed) {
		fname=crypt_filename(filename, seed);
	}

	file=fopen(fname, "w");

	if (file) {
		free(fname);
		return(file);
	}

	fprintf(stderr, "Attempted to open: %s\n", fname);
	perror("ERROR opening file");
	free(fname);
	exit(1);
	
}

char *crypt_filename(const char *filename, int seed) {

	long salt;
	char **tmp;

	salt=strtol(filename,tmp, 36); /* convert the filename to a long number */
	salt+=(long)seed;
	salt=salt^key;
	
	return(name(salt, filename, 8));
}

char *name(long salt, const char *oname, int length) {

	char saltc[3];
	char *t, *p;
	int i, c;
	
	saltc[0]=salt & 077;
	saltc[1]=(salt>>6) & 077;
	saltc[2]='\0';

	for (i=0;i<2;i++) {
		c=saltc[i]+'.';
		if (c>'9') c+=7;
		if (c>'Z') c+=6;
		saltc[i]=c;
	}

	p=t=(char *)calloc(sizeof(char), length+1);
	strncpy(t, crypt(oname, saltc), length);

	for(;*t;) {
		*(t)=*(t) & 077;
		*(t)+='.';
		if (*(t)>'9') *(t)+=7;
		if (*(t)>'Z') *(t)+=6;
		t++;
	}

	return(p);
}

void create_addr(char *addrp) {

	char *p, *pi, *ap, *ep;
	char tmp[256];
	int i;
	int al, el;
	int gen;

	if (randaddlen) {
		al=3+(int)(50.0 * rand()/(RAND_MAX+1.0)); // Generate random number between 3 and 60
		el=3+(int)(13.0 * rand()/(RAND_MAX+1.0)); // Generate random number between 3 and 16
	} else {
		al=domlength;
		el=emaillen;
	}

	if (randhost) {}

	memset(addrp, '\0', 256);
	memset(tmp, '\0', 256);

	for (i=0; i<256; i++) {
		gen=(int)(36.0 * rand()/RAND_MAX);
		tmp[i]=chars[gen];
	}
	strncpy(addrp, tmp, el + al + 1);
	addrp[el]='@';

}

void setsuffix(char *addrp) {

	int i;
	int suffixes;

	if (!randsuffix) {
		suffixes=15;
	} else {
		suffixes=SUFFIXES;
	}

	i=(int)((float)suffixes * rand()/RAND_MAX);
	strcat(addrp, ".");
	strcat(addrp, allsuffixes[i]);
	
}

void gencgi_header(FILE *fp) {

	/* insert any other headers you fancy.... */
	fprintf(fp, "Cache-Control: post-check=0, pre-check=0\n");
	fprintf(fp, "Pragma: no-cache\n");
	fprintf(fp, "Content-type: text/html; charset=iso-8859-1\n\n");

}

void get_string(char *sp) {

	int i;
	int gen;
	
	memset(sp, '\0', 10);

	for (i=0; i<((int)(8.0 *rand()/RAND_MAX) + 2); i++) {
		gen=(int)(36.0 * rand()/RAND_MAX);
		sp[i]=chars[gen];
	}

}

void readconfig(void) {

	/* TODO */

}

int getopts(int ac, char **av) {

	int i;
	long key;
	
	/* first check command line vars....
	 * 2 modes:
	 *
	 * 1/ Command line to generate static pages.
	 * 2/ dynamic mode - config file and no command line options
	 *
	 * Command line options:
	 * -n <1000> number of generated addresses per page
	 * -p <5> number of calls for other pages
	 * -d <8> max. length of domain strings (3-64) not including suffix.
	 * -e <8> max. length of e-mail address parts
	 * -r [present] will force address length randomization
	 *              (to lengths specified by options 'e' and 'd')
	 * -s [present] will force address suffix to be randomized
	 * -s [not present] will use .com .net and .org suffixes only
	 * -g [present] do not add random text 'garbage' to pages
	 *              (garbage is random groups of characters as text)
	 * -h [present] use random hostnames in the current domain.
	 * -f <pollute.htm> specify the starting filename
	 *
	 * Config File Options:
	 *
	 * <to be completed>
	 *
	 */

	for (i=1 ; i<ac; i++) {

		if (av[i][0] == '-') {

			if (!av[i][1]) usage(av[0]);
	
			switch (av[i++][1]) {
	
				case 'n':
					msgsperpage=atoi(av[i]);
					break;
				case 'p':
					numpages=atoi(av[i]);
					break;
				case 'd':
					domlength=atoi(av[i]);
					break;
				case 'e':
					emaillen=atoi(av[i]);
					break;
				case 'r':
					randaddlen=TRUE;
					i--;
					break;
				case 's':
					randsuffix=TRUE;
					i--;
					break;
				case 'g':
					garbage=TRUE;
					i--;
					break;
				case 'h':
					randhost=TRUE;
					i--;
					break;
				case 'f':
					strncpy(filename, av[i], strlen(av[i])<64?strlen(av[i]):64);
					filename[64]='\0';
					break;
				default:
					printf("Unknown option -%c... ", av[--i][1]);
					usage(av[0]);
				break;
			}
		} else {
			usage(av[0]);
		}
	}

}

void usage(char *self) {

	int i;
	char spacer[100];

	i=strlen(self);
	memset(spacer, ' ', 64);
	spacer[i+10]='\0';

	printf("Usage: %s [ -n <number> ] [ -p <number> ] [ -d <number> ] [ -e [number] ] [ -r ] [ -s ] [ -g ] [ -h ] [ -f <filename> ]\n", self);
	printf("%s -n <number>    -  Number of addresses per page [default=1000]\n", spacer);
	printf("%s -p <number>    -  Number of pages per page [default=5] (special webserver config required).\n", spacer);
	printf("%s -d <number>    -  Number of domain name length [default=8].\n", spacer);
	printf("%s -e <number>    -  Number of email address length [default=8].\n", spacer);
	printf("%s -r             -  Randomise address (domain) length [default=no].\n",spacer);
	printf("%s -s             -  Use All Suffixes [default=no]\n",spacer);
	printf("%s -g             -  Include garbage text [default=no].\n",spacer);
	printf("%s -h             -  Add Randomised hostname [default=no].\n",spacer);
	printf("%s -f <filename>  -  Initial Filename [default='pollute.htm']\n", spacer);
	exit (1);
}
	

